# coding: utf-8

"""
    osparc.io public API

    osparc-simcore public API specifications

    The version of the OpenAPI document: 0.8.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class GetCreditPriceLegacy(BaseModel):
    """
    GetCreditPriceLegacy
    """ # noqa: E501
    product_name: StrictStr = Field(alias="productName")
    usd_per_credit: Optional[Union[Annotated[float, Field(strict=True, ge=0.0)], Annotated[int, Field(strict=True, ge=0)]]] = Field(alias="usdPerCredit")
    min_payment_amount_usd: Optional[Annotated[int, Field(strict=True, ge=0)]] = Field(alias="minPaymentAmountUsd")
    __properties: ClassVar[List[str]] = ["productName", "usdPerCredit", "minPaymentAmountUsd"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetCreditPriceLegacy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if usd_per_credit (nullable) is None
        # and model_fields_set contains the field
        if self.usd_per_credit is None and "usd_per_credit" in self.model_fields_set:
            _dict['usdPerCredit'] = None

        # set to None if min_payment_amount_usd (nullable) is None
        # and model_fields_set contains the field
        if self.min_payment_amount_usd is None and "min_payment_amount_usd" in self.model_fields_set:
            _dict['minPaymentAmountUsd'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetCreditPriceLegacy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "productName": obj.get("productName"),
            "usdPerCredit": obj.get("usdPerCredit"),
            "minPaymentAmountUsd": obj.get("minPaymentAmountUsd")
        })
        return _obj


