# coding: utf-8

"""
    osparc.io public API

    osparc-simcore public API specifications

    The version of the OpenAPI document: 0.8.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from osparc_client.models.licensed_resource import LicensedResource
from osparc_client.models.licensed_resource_type import LicensedResourceType
from typing import Optional, Set
from typing_extensions import Self

class LicensedItemGet(BaseModel):
    """
    LicensedItemGet
    """ # noqa: E501
    licensed_item_id: StrictStr
    key: StrictStr
    version: Annotated[str, Field(strict=True)]
    display_name: StrictStr
    licensed_resource_type: LicensedResourceType
    licensed_resources: List[LicensedResource]
    pricing_plan_id: Annotated[int, Field(strict=True, ge=0)]
    is_hidden_on_market: StrictBool
    created_at: datetime
    modified_at: datetime
    __properties: ClassVar[List[str]] = ["licensed_item_id", "key", "version", "display_name", "licensed_resource_type", "licensed_resources", "pricing_plan_id", "is_hidden_on_market", "created_at", "modified_at"]

    @field_validator('version')
    def version_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^\d+\.\d+\.\d+$", value):
            raise ValueError(r"must validate the regular expression /^\d+\.\d+\.\d+$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LicensedItemGet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in licensed_resources (list)
        _items = []
        if self.licensed_resources:
            for _item_licensed_resources in self.licensed_resources:
                if _item_licensed_resources:
                    _items.append(_item_licensed_resources.to_dict())
            _dict['licensed_resources'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LicensedItemGet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "licensed_item_id": obj.get("licensed_item_id"),
            "key": obj.get("key"),
            "version": obj.get("version"),
            "display_name": obj.get("display_name"),
            "licensed_resource_type": obj.get("licensed_resource_type"),
            "licensed_resources": [LicensedResource.from_dict(_item) for _item in obj["licensed_resources"]] if obj.get("licensed_resources") is not None else None,
            "pricing_plan_id": obj.get("pricing_plan_id"),
            "is_hidden_on_market": obj.get("is_hidden_on_market"),
            "created_at": obj.get("created_at"),
            "modified_at": obj.get("modified_at")
        })
        return _obj


