# coding: utf-8

"""
    osparc.io public API

    osparc-simcore public API specifications

    The version of the OpenAPI document: 0.8.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from osparc_client.models.registered_project_function_job import RegisteredProjectFunctionJob
from osparc_client.models.registered_python_code_function_job import RegisteredPythonCodeFunctionJob
from osparc_client.models.registered_solver_function_job import RegisteredSolverFunctionJob
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

RESPONSEREGISTERFUNCTIONJOBV0FUNCTIONJOBSPOST_ONE_OF_SCHEMAS = ["RegisteredProjectFunctionJob", "RegisteredPythonCodeFunctionJob", "RegisteredSolverFunctionJob"]

class ResponseRegisterFunctionJobV0FunctionJobsPost(BaseModel):
    """
    ResponseRegisterFunctionJobV0FunctionJobsPost
    """
    # data type: RegisteredProjectFunctionJob
    oneof_schema_1_validator: Optional[RegisteredProjectFunctionJob] = None
    # data type: RegisteredPythonCodeFunctionJob
    oneof_schema_2_validator: Optional[RegisteredPythonCodeFunctionJob] = None
    # data type: RegisteredSolverFunctionJob
    oneof_schema_3_validator: Optional[RegisteredSolverFunctionJob] = None
    actual_instance: Optional[Union[RegisteredProjectFunctionJob, RegisteredPythonCodeFunctionJob, RegisteredSolverFunctionJob]] = None
    one_of_schemas: Set[str] = { "RegisteredProjectFunctionJob", "RegisteredPythonCodeFunctionJob", "RegisteredSolverFunctionJob" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ResponseRegisterFunctionJobV0FunctionJobsPost.model_construct()
        error_messages = []
        match = 0
        # validate data type: RegisteredProjectFunctionJob
        if not isinstance(v, RegisteredProjectFunctionJob):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RegisteredProjectFunctionJob`")
        else:
            match += 1
        # validate data type: RegisteredPythonCodeFunctionJob
        if not isinstance(v, RegisteredPythonCodeFunctionJob):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RegisteredPythonCodeFunctionJob`")
        else:
            match += 1
        # validate data type: RegisteredSolverFunctionJob
        if not isinstance(v, RegisteredSolverFunctionJob):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RegisteredSolverFunctionJob`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ResponseRegisterFunctionJobV0FunctionJobsPost with oneOf schemas: RegisteredProjectFunctionJob, RegisteredPythonCodeFunctionJob, RegisteredSolverFunctionJob. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ResponseRegisterFunctionJobV0FunctionJobsPost with oneOf schemas: RegisteredProjectFunctionJob, RegisteredPythonCodeFunctionJob, RegisteredSolverFunctionJob. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into RegisteredProjectFunctionJob
        try:
            instance.actual_instance = RegisteredProjectFunctionJob.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RegisteredPythonCodeFunctionJob
        try:
            instance.actual_instance = RegisteredPythonCodeFunctionJob.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RegisteredSolverFunctionJob
        try:
            instance.actual_instance = RegisteredSolverFunctionJob.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ResponseRegisterFunctionJobV0FunctionJobsPost with oneOf schemas: RegisteredProjectFunctionJob, RegisteredPythonCodeFunctionJob, RegisteredSolverFunctionJob. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ResponseRegisterFunctionJobV0FunctionJobsPost with oneOf schemas: RegisteredProjectFunctionJob, RegisteredPythonCodeFunctionJob, RegisteredSolverFunctionJob. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], RegisteredProjectFunctionJob, RegisteredPythonCodeFunctionJob, RegisteredSolverFunctionJob]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


