# coding: utf-8

"""
    osparc.io public API

    osparc-simcore public API specifications

    The version of the OpenAPI document: 0.8.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from osparc_client.models.wallet_status import WalletStatus
from typing import Optional, Set
from typing_extensions import Self

class WalletGetWithAvailableCreditsLegacy(BaseModel):
    """
    WalletGetWithAvailableCreditsLegacy
    """ # noqa: E501
    wallet_id: Annotated[int, Field(strict=True, ge=0)] = Field(alias="walletId")
    name: Annotated[str, Field(min_length=1, strict=True, max_length=100)]
    description: Optional[StrictStr] = None
    owner: Annotated[int, Field(strict=True, ge=0)]
    thumbnail: Optional[StrictStr] = None
    status: WalletStatus
    created: datetime
    modified: datetime
    available_credits: Union[Annotated[float, Field(strict=True, ge=0.0)], Annotated[int, Field(strict=True, ge=0)]] = Field(alias="availableCredits")
    __properties: ClassVar[List[str]] = ["walletId", "name", "description", "owner", "thumbnail", "status", "created", "modified", "availableCredits"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WalletGetWithAvailableCreditsLegacy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if thumbnail (nullable) is None
        # and model_fields_set contains the field
        if self.thumbnail is None and "thumbnail" in self.model_fields_set:
            _dict['thumbnail'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WalletGetWithAvailableCreditsLegacy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "walletId": obj.get("walletId"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "owner": obj.get("owner"),
            "thumbnail": obj.get("thumbnail"),
            "status": obj.get("status"),
            "created": obj.get("created"),
            "modified": obj.get("modified"),
            "availableCredits": obj.get("availableCredits")
        })
        return _obj


